#!/usr/bin/env python
# coding: utf-8

# In[ ]:


def main():
        model = DO-ResNet().to(device)
        criterion = torch.nn.MSELoss().to(device)
        optimizer = RAdam(model.parameters(), lr=learning_rate,weight_decay=0.004)
        early_stopping = EarlyStopping(patiences, verbose=True)
        scheduler = torch.optim.lr_scheduler.ReduceLROnPlateau(optimizer, mode='min', factor=0.1, patience=10, verbose=1, cooldown=0, min_lr=1e-05)

        for epoch in range(num_epochs):
            model.train()
            print('train:')
            for i in range(math.floor((train_x.shape[0])/batch_size)):
                idx_t = np.random.randint(train_x.shape[0],size=batch_size)
                train_x_t = torch.tensor(train_x[idx_t,:]).type(torch.FloatTensor).to(device)
                train_y_t =torch.tensor(train_y[idx_t,:]).type(torch.FloatTensor).to(device)

                optimizer.zero_grad()
                predict_t = model(train_x_t)
                loss = criterion(predict_t, train_y_t)
                
                loss.backward()
                optimizer.step()


                if (i+1) % (math.floor((train_x.shape[0])/batch_size)) == 0:
                    print("epoch:", epoch, "step:", i, "mse:", loss.item(),"predict_t:",predict_t.shape,"train_y_t:",train_y_t.shape)#,"predict_t:",predict_t,"train_conv_MLD_t:",train_conv_MLD_t


            model.eval()  #模型切换到评估
            print('test:')
            idx_test = np.random.randint(test_x.shape[0],size=batch_size_t)
            test_x_t = torch.tensor(test_x[idx_test,:]).type(torch.FloatTensor).to(device)
            test_y_t =torch.tensor(test_y[idx_test,:]).type(torch.FloatTensor).to(device)
            predict_test = model(test_x_t)
            loss_test =criterion(predict_test, test_y_t)
            print(predict_test.shape)
            print(test_y_t.shape)
            print( "loss:", loss_test.item(),"predict_t:",predict_test.shape,"test_y_t:",test_y_t.shape)
            early_stopping(loss_test, model)
            if early_stopping.early_stop:
                print("Early stopping")
                break
            scheduler.step(loss)


        torch.save(model.state_dict(), "") 

